<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/modifyprop_par.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>modifyprop_par.c</h1><a href="modifyprop__par_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: modifyprop_par.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="modifyprop__par_8c.html#a5b18b26ca79926b582bf94e21e5f531b">00030</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a5b18b26ca79926b582bf94e21e5f531b">ModifyPropPar</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> rank,size;
<a name="l00035"></a>00035   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00036"></a>00036   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   PetscTruth flg;
<a name="l00039"></a>00039   <span class="keywordtype">int</span> nsliceprop;
<a name="l00040"></a>00040   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-nsliceproppar&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nsliceprop,&amp;flg);CHKERRQ(ierr);
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00042"></a>00042     <span class="comment">/* set default values if option is missing */</span>
<a name="l00043"></a>00043     nsliceprop=0;
<a name="l00044"></a>00044     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00045"></a>00045       <span class="stringliteral">&quot;Option -nsliceproppar not found, using default value %i!\n&quot;</span>,
<a name="l00046"></a>00046       nsliceprop
<a name="l00047"></a>00047     );
<a name="l00048"></a>00048   }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">/* exit if there is nothing to modify */</span>
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (nsliceprop&lt;=0) {
<a name="l00052"></a>00052     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00053"></a>00053       <span class="stringliteral">&quot;nsliceproppar==%i, nothing modified!\n&quot;</span>,
<a name="l00054"></a>00054       nsliceprop
<a name="l00055"></a>00055     );
<a name="l00056"></a>00056     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">/* sliced4.out */</span>
<a name="l00060"></a>00060   PetscReal ep0, ew; <span class="comment">/* element &quot;position&quot;, width */</span>
<a name="l00061"></a>00061   ep0= 0.1;
<a name="l00062"></a>00062   ew=  0.25;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keywordtype">int</span> ps0, ns; <span class="comment">/* prop. id of first slice, no. of slices (properties) */</span>
<a name="l00065"></a>00065   ps0=15;
<a name="l00066"></a>00066   ns= 40;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00069"></a>00069     <span class="stringliteral">&quot;modifyprop: element position: %g width: %g propid: [%i,%i]\n&quot;</span>,
<a name="l00070"></a>00070     ep0,
<a name="l00071"></a>00071     ew,
<a name="l00072"></a>00072     ps0,
<a name="l00073"></a>00073     ps0+ns-1
<a name="l00074"></a>00074   );
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordflow">if</span> (ps0&lt;gdata-&gt;n_prop) {
<a name="l00077"></a>00077     SETERRQ1(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;ps0 &lt; gdata-&gt;n_prop in %s\n&quot;</span>,<a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">__FUNCT__</a>);
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordflow">if</span> (ns != nsliceprop) {
<a name="l00081"></a>00081     SETERRQ1(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;ns != nsliceproppar in %s\n&quot;</span>,<a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">__FUNCT__</a>);
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a> += ns;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00087"></a>00087     <span class="stringliteral">&quot;modifyprop: rereading %s.krn for %i additional properties\n&quot;</span>,
<a name="l00088"></a>00088     gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,
<a name="l00089"></a>00089     ns
<a name="l00090"></a>00090   );
<a name="l00091"></a>00091   ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00092"></a>00092   ierr = <a class="code" href="magpario_8h.html#a59544353738dfce0bdce48409d9b3c8b">ReadKrn</a>(gdata);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (rank) {
<a name="l00095"></a>00095     ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00096"></a>00096   }
<a name="l00097"></a>00097   ierr = MPI_Bcast(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;ns; j++) {
<a name="l00100"></a>00100     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00101"></a>00101       <span class="keywordtype">int</span> k;
<a name="l00102"></a>00102       <span class="comment">/* get x-coordinate of first vertex */</span>
<a name="l00103"></a>00103       PetscReal sgn;
<a name="l00104"></a>00104       sgn=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+0]-(ep0+ew*j);
<a name="l00105"></a>00105       <span class="keywordflow">for</span> (k=1;k&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;k++) {
<a name="l00106"></a>00106         <span class="comment">/* multiply with other x-coordinate of other vertices</span>
<a name="l00107"></a>00107 <span class="comment">           if (product &lt; 0) then they have opposite signs and</span>
<a name="l00108"></a>00108 <span class="comment">           the element must be cut by the slice plane</span>
<a name="l00109"></a>00109 <span class="comment">        */</span>
<a name="l00110"></a>00110         <span class="keywordflow">if</span> (sgn*(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+k]+0]-(ep0+ew*j)) &lt; 0.0)
<a name="l00111"></a>00111           <span class="keywordflow">break</span>;
<a name="l00112"></a>00112       }
<a name="l00113"></a>00113       <span class="keywordflow">if</span> (k&lt;NV) {
<a name="l00114"></a>00114         gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]=ps0+j;
<a name="l00115"></a>00115       }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">/* does not always work (due to strongly deformed elements)</span>
<a name="l00118"></a>00118 <span class="comment">      if (PetscAbsReal(</span>
<a name="l00119"></a>00119 <span class="comment">            PetscAbsReal(gdata-&gt;vertxyz[ND*gdata-&gt;elevert[NV*i+0]+0]+</span>
<a name="l00120"></a>00120 <span class="comment">                 gdata-&gt;vertxyz[ND*gdata-&gt;elevert[NV*i+1]+0]+</span>
<a name="l00121"></a>00121 <span class="comment">                 gdata-&gt;vertxyz[ND*gdata-&gt;elevert[NV*i+2]+0]+</span>
<a name="l00122"></a>00122 <span class="comment">                 gdata-&gt;vertxyz[ND*gdata-&gt;elevert[NV*i+3]+0]</span>
<a name="l00123"></a>00123 <span class="comment">                )/NV-(ep-j*ew)</span>
<a name="l00124"></a>00124 <span class="comment">              ) &lt;= et</span>
<a name="l00125"></a>00125 <span class="comment">         ) {</span>
<a name="l00126"></a>00126 <span class="comment">        gdata-&gt;eleprop[i]=ps0+j;</span>
<a name="l00127"></a>00127 <span class="comment">      }</span>
<a name="l00128"></a>00128 <span class="comment">*/</span>
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

